// The editor object
var ZSSEditor = {};

ZSSEditor.editor = document.getElementById('zss_field_content');
ZSSEditor.title = document.getElementById('zss_field_title');
ZSSEditor.images = document.getElementsByClassName("wp-image");
ZSSEditor.rightButton = document.getElementById('title-right-button');

ZSSEditor.currentSelection = {
    "startContainer": 0,
    "startOffset": 0,
    "endContainer": 0,
    "endOffset": 0};

ZSSEditor.backuprange = function(){
    var selection = window.getSelection();
    if (selection.rangeCount > 0) {
        var range = selection.getRangeAt(0);
        ZSSEditor.currentSelection = {
            "startContainer": range.startContainer,
            "startOffset": range.startOffset,
            "endContainer": range.endContainer,
            "endOffset": range.endOffset};
    }
}

ZSSEditor.init = function () {
//    Array.prototype.forEach.call(ZSSEditor.images, function (image) {//遍历所有的普通图片
//        image.addEventListener("click", ZSSEditor.imageTapCallback);
//    });

    //输入框焦点改变
    document.addEventListener("selectionchange", ZSSEditor.selectionChangedCallback);

    //监听图片点击事件
    document.addEventListener("click", ZSSEditor.handleClicckEvent);//ev.target.nodeName,ev.target.className

    //监听按下事件
    document.addEventListener('keydown', ZSSEditor.keydownCallback);
    document.addEventListener('keyup', ZSSEditor.keydownCallback);
    document.addEventListener('paste', ZSSEditor.pasteCallback);
}

ZSSEditor.pasteCallback = function (ev) {
    var id = ev.target.id;
    if (id == null) return;

    if ( !(ev.clipboardData && ev.clipboardData.items) ) {
        return;
    }

    var length = ev.clipboardData.getData('text/plain').length;

    if (id == "zss_field_title") {
        ZSSEditor.preventInput(ev, 50);
    }

    if (id == "zss_field_content") {
            var textContent = ev.target.innerText.replace(/\s+/g,"");
            var len = 5000- textContent.length - length;//还能输入的文本内容
            ZSSEditor.callback('callback-remain-input', len);
        }
}



ZSSEditor.keydownCallback = function (ev) {
    var id = ev.target.id;
    if (id == null) return;

    if (id == "zss_field_title") {
        ZSSEditor.preventInput(ev, 50);
    }

    if (id == "zss_field_content") {
            var goodsItems = document.getElementsByTagName("section");
            var length = 0;
            Array.prototype.forEach.call(goodsItems, function (item) {
                length += item.innerText.replace(/\s+/g,"").length;
            });
            var textContent = ev.target.innerText.replace(/\s+/g,"");
            var len = 5000- textContent.length + length;//还能输入的文本内容
    //        var len = 5000- ev.target.innerText.length - length;//还能输入的文本内容
            ZSSEditor.callback('callback-remain-input', len);
    //        ZSSEditor.preventInput(ev, 5000 + length);
        }
}

ZSSEditor.preventInput = function (ev, length) {
    var target = ev.target;
        var text = target.innerText;
        if (text != null && text.length > length && ev.keyCode != 8) {//删除
            var isChrome = navigator.userAgent.indexOf("Chrome") > -1
            if(isChrome){
                target.innerText = text.substr(0,length);
                                    target.blur();
            }else{
                ev.preventDefault();
            }
        }
}


//图片点击事件
ZSSEditor.handleClicckEvent = function (ev) {
    if(ev.target.nodeName == "IMG" && ev.target.className == "wp-image"){
        document.getElementById('zss_field_content').blur();
        ZSSEditor.callback('callback-image-tap', ev.target.src);
    }
}

//输入框焦点改变
ZSSEditor.selectionChangedCallback = function (ev) {
    ZSSEditor.callback('callback-selection-changed', ev.target.activeElement.id);
}

//js 调用java
ZSSEditor.callback = function (callbackScheme, callbackPath) {
    nativeCallbackHandler.executeCallback(callbackScheme, callbackPath);
}


ZSSEditor.prepareInsert = function() {
    ZSSEditor.backuprange();
}

ZSSEditor.restorerange = function(){
    var selection = window.getSelection();
    selection.removeAllRanges();
    var range = document.createRange();
    range.setStart(ZSSEditor.currentSelection.startContainer, ZSSEditor.currentSelection.startOffset);
    range.setEnd(ZSSEditor.currentSelection.endContainer, ZSSEditor.currentSelection.endOffset);
    selection.addRange(range);
}

ZSSEditor.insertImage = function(url,width,height ,alt) {
    var html = '<div><p><img src="' + url + '" alt="' + alt + '" mmWidth="'+width+'" mmHeight="'+height+'" class=wp-image /></p><br/></div>';
    ZSSEditor.insertHTML(html);
}

ZSSEditor.insertEmoji = function(url, alt) {
    var html = '<img src="' + url + '" alt="' + alt + '" class=emoji />';
    ZSSEditor.insertHTML(html);
}

ZSSEditor.insertGoods = function(id,thumbnail,title,desc,originPrice,marketPrice){
//    var html = '<div class="goods_line"><br/></div><section contenteditable="false" class="wrap"><div contenteditable="false" class="pro-box"><div contenteditable="false" class="left"><img contenteditable="false" src="'+thumbnail+'" alt=""><span contenteditable="false" class="like">'+catetory+'</span></div><div contenteditable="false" class="right"><h2 contenteditable="false" class="title">'+title+'</h2><p contenteditable="false" class="des">'+desc+'</p><div contenteditable="false" class="buy"><span contenteditable="false" class="price">'+originPrice+'</span><span contenteditable="false" class="price-d">'+marketPrice+'</span><a contenteditable="false" class="pro-buy" id="'+id+'">去购买</a></div></div></div></section><div><br/></div>'
    //contenteditable="true"
    var html = '<div class="goods_line"><br/></div><section id="'+id+'" class="wrap"><div class="pro-box"><div class="left"><img class="goods-image"  src="'+thumbnail+'" alt=""><span class="like"></span></div><div class="right"><h2 class="title">'+title+'</h2><p class="des">'+desc+'</p><div class="buy"><span class="price">'+marketPrice+'</span><span class="price-d">'+originPrice+'</span><a class="pro-buy">去购买</a></div></div></div></section><div><br/></div>'
    ZSSEditor.insertHTML(html);
}

ZSSEditor.insertHTML = function(html) {
    ZSSEditor.restorerange();
    document.execCommand('insertHTML', false, html);
}

ZSSEditor.setContentPlaceholderText = function (placeholder) {
    ZSSEditor.editor.setAttribute("placeholderText", placeholder);
}

ZSSEditor.setTitlePlaceholderText = function (placeholder) {
    ZSSEditor.title.setAttribute("placeholderText", placeholder);
}

ZSSEditor.blurFocus = function() {
    ZSSEditor.editor.blur();
}

ZSSEditor.getContentHtml = function() {
    return ZSSEditor.editor.innerHTML;
}

ZSSEditor.getTitleHtml = function () {
    return ZSSEditor.title.innerHTML;
}

ZSSEditor.getContentHTMLForCallback = function(){
     ZSSEditor.callback("callback-response-content",ZSSEditor.getContentHtml()/*encodeURI()*/);
}

ZSSEditor.getTitleHTMLForCallback = function(){
     ZSSEditor.callback("callback-response-title",ZSSEditor.getTitleHtml()/*encodeURI()*/);
}

ZSSEditor.editor.addEventListener("input", ZSSEditor.getContentHTMLForCallback);
ZSSEditor.title.addEventListener("input", ZSSEditor.getTitleHTMLForCallback);
//ZSSEditor.editor.addEventListener("click", ZSSEditor.selectionChangedCallback);
//ZSSEditor.title.addEventListener("click", ZSSEditor.selectionChangedCallback);

ZSSEditor.showTitleChooseColorButton = function(show) {
    var rightButton = ZSSEditor.rightButton || (ZSSEditor.rightButton = document.getElementById('title-right-button'));
    if (rightButton) {
        if (show) {
            rightButton.style.display = "";
        } else {
            rightButton.style.display = "none";
        }
    }
}


ZSSEditor.changeTitleRightButtonColor = function(color) {
    var rightButton = ZSSEditor.rightButton || (ZSSEditor.rightButton = document.getElementById('title-right-button'));
    if (rightButton) {
        rightButton.style.backgroundColor = color;
    }
    if (ZSSEditor.title) {
        ZSSEditor.title.style.color = color;
    }
}

ZSSEditor.rightButton.addEventListener("click", function() {
    var curColor = ZSSEditor.rightButton.style.backgroundColor;
    ZSSEditor.callback('callback_title_choose_color', curColor.rgb2hex());
});

String.prototype.rgb2hex = function() {
    return "#" + this.split('(')[1].split(',').map(function(x){
        x = parseInt(x).toString(16);
        return (x.length == 1) ? '0' + x : x;
    }).join('');
}